
import java.util.*;

public class DivisionByZero {

    public static int quotient(int numerator, int denominator) 
      throws ArithmeticException
    {
	return (numerator/denominator);
    }

    public static void main (String args[]) {
  
	Scanner scanner = new Scanner(System.in);
	boolean repeat = true;

	do {
	  try {
	    System.out.print("Numerador: ");
	    int num = scanner.nextInt();

	    System.out.print("Denominador: ");
	    int den = scanner.nextInt();

	    int res = quotient(num, den);
	    System.out.printf("Resultado: %d\n", res);
	    repeat = false;
	  } 
	  // essa excecao eh lancada pela classe Scanner
	  // e esta sendo tratada aqui
	  catch ( InputMismatchException inputMEx ) {
	    System.err.printf("Excecao 1: %s\n", inputMEx);
	    scanner.nextLine();
	    System.out.println("Por favor entre apenas com inteiros. Tente novamente");
	  }
	  // essa excecao eh lancada dentro do metodo quotient
	  catch ( ArithmeticException inputAEx ) {
	    System.err.printf("Excecao 2: %s\n", inputAEx);
	    System.out.println("Zero e um denominador invalido. Tente novamente");
	  }
	  finally {
	    System.out.println("Bloco finally - sempre executado");
	  }
	} while ( repeat );
    }
} 
